# Wireless security tools

## Wireless Intrusion Prevention Systems (WIPS)

- Also known as **Wireless IPS**
- Network device
- 📝 Intrusion detection by monitoring the radio spectrum for the presence of unauthorized access points (e.g. evil twins)
- Intrusion prevention by taking steps to mitigate the threat (e.g. deattaching it).
- E.g. • [Cisco Adaptive Wireless IPS](https://www.cisco.com/c/en/us/products/wireless/adaptive-wireless-ips-software/index.html) • [WatchGuard WIPS](https://www.watchguard.com/wgrd-products/access-points/wips)

### Wireless Intrusion Detection Systems (WIDS)

- Also known as **Wireless IDS**
- Monitors radio spectrum used by wireless LANs and alerts whenever a rogue access point is detected.
- Alerts a systems administrator whenever a rogue access point is detected

## Wi-Fi security auditing tools

- [AirMagnet® WiFi Analyzer PRO](https://www.netally.com/products/airmagnet-wifi-analyzer/)
  - Real-time analysis of 802.11a/b/g/n/ac wireless networks
- [RFProtect Wireless Intrusion Protection](https://www.arubanetworks.com/products/security/wireless-intrusion-protection/)
  - Prevents denial-of-service and man-in-the-middle attacks and mitigates over-the-air security threats.
- [FruityWiFi](http://www.fruitywifi.com)
  - Open source tool to audit wireless networks
  - Allows the user to deploy advanced attacks by directly using the web interface or by sending messages to it.
- [Fern Wifi Cracker](https://github.com/savio-code/fern-wifi-cracker)
  - Security auditing and attack software program
  - Can run attacks such as cracking WEP/WPA/WPS keys
- [OSWA-Assistant](http://securitystartshere.org/page-software-oswa-assistant.htm)
  - Organizational System Wirelss Auditor

## Wi-Fi predictive planning tools

- Allows to plan and design Wi-Fi 6 networks
- E.g.
  - [AirMagnet® Planner](https://www.netally.com/products/airmagnet-planner/)
    - Plan networks, estimate budgets, optimize, plan mitigation strategies
  - [Cisco Prime Infrastructure](https://www.cisco.com/c/en/us/products/cloud-systems-management/prime-infrastructure/index.html)
    - Solution for provisioning, monitoring, optimizing, and troubleshooting both wired and wireless devices
  - [Ekahau Pro](https://www.ekahau.com/products/ekahau-connect/pro/)
    - Tool for designing, analyzing, optimizing, and troubleshooting Wi-Fi networks.
  - [TamoGraph Site Survey](https://www.tamos.com/products/wifi-site-survey/)
    - Wireless site survey software tool for collecting, visualizing, and analyzing 802.11 a/b/g/n/ac/ax Wi-Fi data.
  - [NetSpot](https://www.netspotapp.com/)
    - Wi-Fi analysis, and troubleshooting on Mac OS X and Windows.
    - Visualize, manage, troubleshoot, audit, plan, and deploy your wireless networks.

## Wi-Fi vulnerability scanning tools

- [Zenmap](https://Nmap.org/zenmap/)
  - Official Nmap GUI.
- [Nessus](https://www.tenable.com/products/nessus)
  - Read more on [vulnerability analysis](./../05-vulnerabilities/vulnerability-analysis.md#nessus)
- [Network Security Toolkit](https://www.networksecuritytoolkit.org)
  - Bootable Fedora with network security tools
- [SecPoint® Penetrator™ Vulnerability Scanner & Assessment](https://www.secpoint.com/penetrator.html)
  - Comes with WiFi pen-testing tools
- [SILICA](https://www.immunityinc.com/products/silica/)
  - Automated, WiFi specific, vulnerability assessment and penetration tool.
- [WebSploit](https://github.com/websploit/websploit)
  - MITM framework with WiFi attacks
- [Airbase-ng](https://aircrack-ng.org)
  - Multi-purpose tool aimed at attacking clients as opposed to the Access Point (AP) itself

## Wi-Fi security tools for mobile

- [Wifi Protector](https://wifi-protector.en.softonic.com/android?ex=CORE-139.6)
  - Android WiFi firewall
- [WiFiGuard](https://www.wifiguardapp.com/)
  - iOS/Android app to scan and detect devices on WiFi network
- [Wifi Inspector](https://play.google.com/store/apps/details?id=lksystems.wifiintruder&hl=en)
  - Android app to scan and detect devices on WiFi network
- [ARP Guard](https://play.google.com/store/apps/details?id=com.myprog.arpguard&hl=en&gl=US)
  - Android app for protection against network attacks including ARP posioning.
